<?php

    define("BUFFERSIZE", 4096);

    function Split2Array(&$string)
    {   // split input string by bytes into output array
        $retbuf = array();
        for ($i = 0; $i < strlen($string); $i++)
            $retbuf[] = $string{$i};
        
        return $retbuf;
    }
    
    function MyArrayCombine(&$array1, &$array2)
    {   // see array_combine() in PHP5
        $retbuf = array();
        $len = min(count($array1), count($array2));
        for ($i = 0; $i < $len; $i++) 
            $retbuf[$array1[$i]] = $array2[$i];
        return $retbuf;
    }
    
    function GetNullifyConvArray()
    {   // array for conversion chars > 128 into null string
        $retbuf = array();
        for ($i = 128; $i < 256; $i++)
            $retbuf[chr($i)] = "";
        
        return $retbuf;
    }
    
    $url = $_REQUEST["url"]; // old method: http://www/myscript/index.php?end=win&url=http://www.seznam.cz/
    
    if (!strlen($url)) // new method: http://www/myscript/?http=//www.seznam.cz/
	    $url = $_SERVER["argv"][0]; 
        // doesn't have to work on all configurations! 
        // sometimes each($_GET) is necessary but it screwes '.' (dots) in the string, changes them to '_' (underscore)
        
    $conv_table = array();
    
    include "iso.php";
    $cesky_asc = Split2Array($cesky_asc_s);
    $cesky_dia = Split2Array($cesky_dia_s);
    $conv_table += MyArrayCombine($cesky_dia, $cesky_asc);
    
    include "win.php";
    $cesky_asc = Split2Array($cesky_asc_s);
    $cesky_dia = Split2Array($cesky_dia_s);
    $conv_table += MyArrayCombine($cesky_dia, $cesky_asc);

    include "utf.php";
    $cesky_asc = Split2Array($cesky_asc_s);
    // $cesky_dia already initialized in utf!
    $conv_table += MyArrayCombine($cesky_dia, $cesky_asc);
    
    $conv_table += array(chr(147) => "-"); // french quote 
    $conv_table += array(chr(132) => "-"); // french quote
    $conv_table += array(chr(160) => " "); // hard-break
    $conv_table += array(chr(133) => "..."); // triple-dot
    // note: some of these special chars might confict with url conversion table
    // and therefor not make it into this conversion table
    $conv_table += GetNullifyConvArray(); // will remove all remaining non-ascii (above 127) chars
    
    if (!$f = fopen($url, "rb"))
        die; // todo: send proper error header
    
    while (!feof($f))
        echo strtr(fread($f, BUFFERSIZE), $conv_table);
    
    fclose($f);
?>
